// components/input/render_input_router.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef COMPONENTS_INPUT_RENDER_INPUT_ROUTER_MOJOM_H_
#define COMPONENTS_INPUT_RENDER_INPUT_ROUTER_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <optional>
#include <type_traits>
#include <utility>

#include "base/types/cxx23_to_underlying.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "components/input/render_input_router.mojom-features.h"  // IWYU pragma: export
#include "components/input/render_input_router.mojom-shared.h"  // IWYU pragma: export
#include "components/input/render_input_router.mojom-forward.h"  // IWYU pragma: export
#include "third_party/blink/public/mojom/widget/platform_widget.mojom-forward.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/lib/message_size_estimator.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"


#include "base/component_export.h"




namespace input::mojom {








class COMPONENT_EXPORT(COMPONENTS_INPUT_MOJOM) RenderInputRouterConfig {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<RenderInputRouterConfig, T>::value>;
  using DataView = RenderInputRouterConfigDataView;
  using Data_ = internal::RenderInputRouterConfig_Data;

  template <typename... Args>
  static RenderInputRouterConfigPtr New(Args&&... args) {
    return RenderInputRouterConfigPtr(
        std::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static RenderInputRouterConfigPtr From(const U& u) {
    return mojo::TypeConverter<RenderInputRouterConfigPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, RenderInputRouterConfig>::Convert(*this);
  }


  RenderInputRouterConfig();

  explicit RenderInputRouterConfig(
      ::mojo::PendingRemote<::blink::mojom::RenderInputRouterClient> rir_client);

RenderInputRouterConfig(const RenderInputRouterConfig&) = delete;
RenderInputRouterConfig& operator=(const RenderInputRouterConfig&) = delete;

  ~RenderInputRouterConfig();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = RenderInputRouterConfigPtr>
  RenderInputRouterConfigPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, RenderInputRouterConfig::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, RenderInputRouterConfig::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, RenderInputRouterConfig::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        RenderInputRouterConfig::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::RenderInputRouterConfig_UnserializedMessageContext<
            UserType, RenderInputRouterConfig::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<RenderInputRouterConfig::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(base::span<const uint8_t> input,
                          UserType* output) {
    return RenderInputRouterConfig::Deserialize(
        input.empty() ? nullptr : input.data(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::RenderInputRouterConfig_UnserializedMessageContext<
            UserType, RenderInputRouterConfig::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<RenderInputRouterConfig::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  ::mojo::PendingRemote<::blink::mojom::RenderInputRouterClient> rir_client;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, RenderInputRouterConfig::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, RenderInputRouterConfig::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, RenderInputRouterConfig::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, RenderInputRouterConfig::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
RenderInputRouterConfigPtr RenderInputRouterConfig::Clone() const {
  return New(
      mojo::Clone(rir_client)
  );
}

template <typename T, RenderInputRouterConfig::EnableIfSame<T>*>
bool RenderInputRouterConfig::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->rir_client, other_struct.rir_client))
    return false;
  return true;
}

template <typename T, RenderInputRouterConfig::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.rir_client < rhs.rir_client)
    return true;
  if (rhs.rir_client < lhs.rir_client)
    return false;
  return false;
}


}  // input::mojom

namespace mojo {


template <>
struct COMPONENT_EXPORT(COMPONENTS_INPUT_MOJOM) StructTraits<::input::mojom::RenderInputRouterConfig::DataView,
                                         ::input::mojom::RenderInputRouterConfigPtr> {
  static bool IsNull(const ::input::mojom::RenderInputRouterConfigPtr& input) { return !input; }
  static void SetToNull(::input::mojom::RenderInputRouterConfigPtr* output) { output->reset(); }

  static  decltype(::input::mojom::RenderInputRouterConfig::rir_client)& rir_client(
       ::input::mojom::RenderInputRouterConfigPtr& input) {
    return input->rir_client;
  }

  static bool Read(::input::mojom::RenderInputRouterConfig::DataView input, ::input::mojom::RenderInputRouterConfigPtr* output);
};

}  // namespace mojo

#endif  // COMPONENTS_INPUT_RENDER_INPUT_ROUTER_MOJOM_H_