// services/network/public/mojom/chunked_data_pipe_getter.mojom-blink.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_NETWORK_PUBLIC_MOJOM_CHUNKED_DATA_PIPE_GETTER_MOJOM_BLINK_H_
#define SERVICES_NETWORK_PUBLIC_MOJOM_CHUNKED_DATA_PIPE_GETTER_MOJOM_BLINK_H_

#include <stdint.h>

#include <limits>
#include <optional>
#include <type_traits>
#include <utility>

#include "base/types/cxx23_to_underlying.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "services/network/public/mojom/chunked_data_pipe_getter.mojom-features.h"  // IWYU pragma: export
#include "services/network/public/mojom/chunked_data_pipe_getter.mojom-shared.h"  // IWYU pragma: export
#include "services/network/public/mojom/chunked_data_pipe_getter.mojom-blink-forward.h"  // IWYU pragma: export

#include "mojo/public/cpp/bindings/lib/wtf_clone_equals_util.h"
#include "mojo/public/cpp/bindings/lib/wtf_hash_util.h"
#include "third_party/blink/renderer/platform/wtf/hash_functions.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/lib/message_size_estimator.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"


#include "third_party/blink/public/platform/web_common.h"




namespace network::mojom::blink {

class ChunkedDataPipeGetterProxy;

template <typename ImplRefTraits>
class ChunkedDataPipeGetterStub;

class ChunkedDataPipeGetterRequestValidator;
class ChunkedDataPipeGetterResponseValidator;


class BLINK_PLATFORM_EXPORT ChunkedDataPipeGetter
    : public ChunkedDataPipeGetterInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = ChunkedDataPipeGetterInterfaceBase;
  using Proxy_ = ChunkedDataPipeGetterProxy;

  template <typename ImplRefTraits>
  using Stub_ = ChunkedDataPipeGetterStub<ImplRefTraits>;

  using RequestValidator_ = ChunkedDataPipeGetterRequestValidator;
  using ResponseValidator_ = ChunkedDataPipeGetterResponseValidator;
  enum MethodMinVersions : uint32_t {
    kGetSizeMinVersion = 0,
    kStartReadingMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct GetSize_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct StartReading_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~ChunkedDataPipeGetter() = default;


  using GetSizeCallback = base::OnceCallback<void(int32_t, uint64_t)>;
  
  virtual void GetSize(GetSizeCallback callback) = 0;

  
  virtual void StartReading(::mojo::ScopedDataPipeProducerHandle pipe) = 0;
};



class BLINK_PLATFORM_EXPORT ChunkedDataPipeGetterProxy
    : public ChunkedDataPipeGetter {
 public:
  using InterfaceType = ChunkedDataPipeGetter;

  explicit ChunkedDataPipeGetterProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void GetSize(GetSizeCallback callback) final;
  
  void StartReading(::mojo::ScopedDataPipeProducerHandle pipe) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class BLINK_PLATFORM_EXPORT ChunkedDataPipeGetterStubDispatch {
 public:
  static bool Accept(ChunkedDataPipeGetter* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      ChunkedDataPipeGetter* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<ChunkedDataPipeGetter>>
class ChunkedDataPipeGetterStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  ChunkedDataPipeGetterStub() = default;
  ~ChunkedDataPipeGetterStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return ChunkedDataPipeGetterStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return ChunkedDataPipeGetterStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_PLATFORM_EXPORT ChunkedDataPipeGetterRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class BLINK_PLATFORM_EXPORT ChunkedDataPipeGetterResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // network::mojom::blink

namespace mojo {

}  // namespace mojo

#endif  // SERVICES_NETWORK_PUBLIC_MOJOM_CHUNKED_DATA_PIPE_GETTER_MOJOM_BLINK_H_