// services/viz/public/mojom/compositing/tiling.mojom-blink.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#endif

#include "services/viz/public/mojom/compositing/tiling.mojom-blink.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/debug/alias.h"
#include "base/hash/md5_constexpr.h"
#include "base/run_loop.h"
#include "base/strings/string_number_conversions.h"
#include "base/task/thread_pool/thread_pool_instance.h"
#include "base/trace_event/trace_event.h"
#include "base/trace_event/typed_macros.h"
#include "mojo/public/cpp/bindings/features.h"
#include "mojo/public/cpp/bindings/lib/default_construct_tag_internal.h"
#include "mojo/public/cpp/bindings/lib/generated_code_util.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/proxy_to_responder.h"
#include "mojo/public/cpp/bindings/lib/send_message_helper.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#include "mojo/public/cpp/bindings/urgent_message_scope.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
#include "third_party/perfetto/include/perfetto/tracing/traced_value.h"

#include "services/viz/public/mojom/compositing/tiling.mojom-params-data.h"
#include "services/viz/public/mojom/compositing/tiling.mojom-shared-message-ids.h"

#include "services/viz/public/mojom/compositing/tiling.mojom-blink-import-headers.h"
#include "services/viz/public/mojom/compositing/tiling.mojom-blink-test-utils.h"
#include "mojo/public/cpp/bindings/lib/wtf_serialization.h"


namespace viz::mojom::blink {
TileResource::TileResource()
    : resource(),
      is_premultiplied(),
      is_checkered() {}

TileResource::TileResource(
    ::viz::mojom::blink::TransferableResourcePtr resource_in,
    bool is_premultiplied_in,
    bool is_checkered_in)
    : resource(std::move(resource_in)),
      is_premultiplied(std::move(is_premultiplied_in)),
      is_checkered(std::move(is_checkered_in)) {}

TileResource::~TileResource() = default;

void TileResource::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "resource"), this->resource,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type ::viz::mojom::blink::TransferableResourcePtr>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "is_premultiplied"), this->is_premultiplied,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type bool>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "is_checkered"), this->is_checkered,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type bool>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool TileResource::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
Tile::Tile()
    : column_index(),
      row_index(),
      contents() {}

Tile::Tile(
    uint32_t column_index_in,
    uint32_t row_index_in,
    TileContentsPtr contents_in)
    : column_index(std::move(column_index_in)),
      row_index(std::move(row_index_in)),
      contents(std::move(contents_in)) {}

Tile::~Tile() = default;

void Tile::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "column_index"), this->column_index,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint32_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "row_index"), this->row_index,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint32_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "contents"), this->contents,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type TileContentsPtr>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool Tile::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
Tiling::Tiling()
    : layer_id(),
      raster_translation(),
      raster_scale(),
      tile_size(),
      tiling_rect(),
      tiles() {}

Tiling::Tiling(
    int64_t layer_id_in,
    const ::gfx::Vector2dF& raster_translation_in,
    const ::gfx::Vector2dF& raster_scale_in,
    const ::gfx::Size& tile_size_in,
    const ::gfx::Rect& tiling_rect_in,
    WTF::Vector<TilePtr> tiles_in)
    : layer_id(std::move(layer_id_in)),
      raster_translation(std::move(raster_translation_in)),
      raster_scale(std::move(raster_scale_in)),
      tile_size(std::move(tile_size_in)),
      tiling_rect(std::move(tiling_rect_in)),
      tiles(std::move(tiles_in)) {}

Tiling::~Tiling() = default;

void Tiling::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "layer_id"), this->layer_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type int64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "raster_translation"), this->raster_translation,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type const ::gfx::Vector2dF&>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "raster_scale"), this->raster_scale,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type const ::gfx::Vector2dF&>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "tile_size"), this->tile_size,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type const ::gfx::Size&>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "tiling_rect"), this->tiling_rect,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type const ::gfx::Rect&>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "tiles"), this->tiles,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type WTF::Vector<TilePtr>>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool Tiling::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
TileContents::TileContents() : tag_(Tag::kMissingReason) {
  data_.missing_reason = MissingTileReason();
}

TileContents::~TileContents() {
  DestroyActive();
}


void TileContents::set_missing_reason(
    MissingTileReason missing_reason) {
  if (tag_ != Tag::kMissingReason) {
    DestroyActive();
    tag_ = Tag::kMissingReason;
  }
  data_.missing_reason = missing_reason;
}
void TileContents::set_resource(
    TileResourcePtr resource) {
  if (tag_ == Tag::kResource) {
    *(data_.resource) = std::move(resource);
  } else {
    DestroyActive();
    tag_ = Tag::kResource;
    data_.resource = new TileResourcePtr(
        std::move(resource));
  }
}
void TileContents::set_solid_color(
    const ::SkColor4f& solid_color) {
  if (tag_ == Tag::kSolidColor) {
    *(data_.solid_color) = std::move(solid_color);
  } else {
    DestroyActive();
    tag_ = Tag::kSolidColor;
    data_.solid_color = new ::SkColor4f(
        std::move(solid_color));
  }
}

void TileContents::DestroyActive() {
  switch (tag_) {

    case Tag::kMissingReason:

      break;
    case Tag::kResource:

      delete data_.resource;
      break;
    case Tag::kSolidColor:

      delete data_.solid_color;
      break;
  }
}

bool TileContents::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context, false);
}


}  // viz::mojom::blink


namespace mojo {


// static
bool StructTraits<::viz::mojom::blink::TileResource::DataView, ::viz::mojom::blink::TileResourcePtr>::Read(
    ::viz::mojom::blink::TileResource::DataView input,
    ::viz::mojom::blink::TileResourcePtr* output) {
  bool success = true;
  ::viz::mojom::blink::TileResourcePtr result(::viz::mojom::blink::TileResource::New());
  
      if (success && !input.ReadResource(&result->resource))
        success = false;
      if (success)
        result->is_premultiplied = input.is_premultiplied();
      if (success)
        result->is_checkered = input.is_checkered();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::viz::mojom::blink::Tile::DataView, ::viz::mojom::blink::TilePtr>::Read(
    ::viz::mojom::blink::Tile::DataView input,
    ::viz::mojom::blink::TilePtr* output) {
  bool success = true;
  ::viz::mojom::blink::TilePtr result(::viz::mojom::blink::Tile::New());
  
      if (success)
        result->column_index = input.column_index();
      if (success)
        result->row_index = input.row_index();
      if (success && !input.ReadContents(&result->contents))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::viz::mojom::blink::Tiling::DataView, ::viz::mojom::blink::TilingPtr>::Read(
    ::viz::mojom::blink::Tiling::DataView input,
    ::viz::mojom::blink::TilingPtr* output) {
  bool success = true;
  ::viz::mojom::blink::TilingPtr result(::viz::mojom::blink::Tiling::New());
  
      if (success)
        result->layer_id = input.layer_id();
      if (success && !input.ReadRasterTranslation(&result->raster_translation))
        success = false;
      if (success && !input.ReadRasterScale(&result->raster_scale))
        success = false;
      if (success && !input.ReadTileSize(&result->tile_size))
        success = false;
      if (success && !input.ReadTilingRect(&result->tiling_rect))
        success = false;
      if (success && !input.ReadTiles(&result->tiles))
        success = false;
  *output = std::move(result);
  return success;
}

// static
bool UnionTraits<::viz::mojom::blink::TileContents::DataView, ::viz::mojom::blink::TileContentsPtr>::Read(
    ::viz::mojom::blink::TileContents::DataView input,
    ::viz::mojom::blink::TileContentsPtr* output) {
  using UnionType = ::viz::mojom::blink::TileContents;
  using Tag = UnionType::Tag;

  switch (input.tag()) {
    case Tag::kMissingReason: {
      ::viz::mojom::blink::MissingTileReason result_missing_reason;
      if (!input.ReadMissingReason(&result_missing_reason))
        return false;

      *output = UnionType::NewMissingReason(result_missing_reason);
      break;
    }
    case Tag::kResource: {
      ::viz::mojom::blink::TileResourcePtr result_resource;
      if (!input.ReadResource(&result_resource))
        return false;

      *output = UnionType::NewResource(
          std::move(result_resource));
      break;
    }
    case Tag::kSolidColor: {
      ::SkColor4f result_solid_color;
      if (!input.ReadSolidColor(&result_solid_color))
        return false;

      *output = UnionType::NewSolidColor(
          std::move(result_solid_color));
      break;
    }
    default:

      return false;
  }
  return true;
}

}  // namespace mojo


// Symbols declared in the -test-utils.h header are defined here instead of a
// separate .cc file to save compile time.


namespace viz::mojom::blink {




}  // viz::mojom::blink


#if defined(__clang__)
#pragma clang diagnostic pop
#endif